package UI_Converter.adminrequest;

/**
 * The Attribute class contains constants related to the UI-TLV attributes.
 *
 * @author Philippe Sidler (SchlumbergerSema, sidler@montrouge.sema.slb.com)
 *
 * @see 3GPP TS 31.113 V5.0.0
 */

/**
IMPORTANT : the numbering of the attributes starts with 0
**/
public class Attribute {
   /**
    * Page attribute related constants.
    */
   public static class AdminRequest {
      /**
       * Index of the Refresh menu attribute.
       */
      public static final int REFRESH_MENU = 1;

      /**
       * Index of the Refresh events attribute.
       */
      public static final int REFRESH_EVENTS = 2;

   }

   /**
    * Navigation Unit attribute related constants.
    */
   public static class InstallPage {
      /**
       * Index of the Access attribute.
       */
      public static final int ACCESS = 1;

   }

   /**
    * Inline Value attribute related constants.
    */
   public static class RemovePage {
      /**
       * Offset of the remove links in the attribute byte.
       */
      public static final int REMOVE_LINKS = 1;
   }

   
}