package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.bytecode.Attribute;
import UI_Converter.common.Tag;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

/**
 * A Display object stores the content of the display XML element and generates
 * the corresponding Display Text UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class Display extends Element {
   /**
    * Create a new Display object.
    *
    * @param atts Attributes of the display XML element.
    */
   public Display(Attributes atts) {
      setTagValue(Tag.DISPLAY_TEXT);

      //handle the attribute "UserInteraction"
	  if (atts.getValue("clear")!=null)
		if (atts.getValue("clear").equals("delay")) setAttribute(Attribute.DisplayText.CLEAR_AFTER_DELAY);

   }
}