package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.bytecode.Attribute;
import UI_Converter.common.Tag;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

/**
 * An ExecuteNativeCommand object stores the content of the
 * execute-native-command XML element and generates the corresponding Execute
 * Native Command UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class ExecuteNativeCommand extends Element {
   /**
    * Create a new ExecuteNativeCommand object.
    *
    * @param atts Attributes of the execute-native-command XML element.
    */
   public ExecuteNativeCommand(Attributes atts) {
      setTagValue(Tag.EXECUTE_NATIVE_COMMAND);
      boolean exit = Conversion.yesNoStringToBoolean(atts.getValue("exit"));
      if (exit) {
         setAttribute(Attribute.ExecuteNativeCommand.EXIT);
      }
   }
}