package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.bytecode.Attribute;
import UI_Converter.common.Tag;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

/**
 * An Exit object stores the content of the exit XML element and generates the
 * corresponding Exit UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class Exit extends Element {
   /**
    * Create a new Exit object.
    *
    * @param atts Attributes of the exit XML element.
    */
   public Exit(Attributes atts) {
      setTagValue(Tag.EXIT);
      boolean terminateSession = Conversion.yesNoStringToBoolean(atts.getValue("terminate-session"));
      if (terminateSession) {
         setAttribute(Attribute.Exit.TERMINATE_SESSION);
      }
   }
}