package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import java.io.ByteArrayOutputStream;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

public class Extract extends Element
{

	private byte[] content;

	public Extract(Attributes atts)
	{
		super();
		setTagValue(Tag.EXTRACT);
		content = new byte[4];

		//handle the attribute "start"
		String start = atts.getValue("start");
		if (start!=null) 
		{
			content[2] = Conversion.stringToByte(start);
		}
		
		//handle the attribute "len"
		String len = atts.getValue("len");
		if (len!=null) 
		{
			content[3] = Conversion.stringToByte(len); 
		}
		
	}

	public int generate(ByteArrayOutputStream buffer)
	{
		//build the content and set it
		Source theSource = (Source) getChild(1);
		OutputVariable theResult = (OutputVariable) getChild(0);

		byte sourceByte = ((Reference)(theSource.getChild(0))).getVarId();
		byte resultByte = ((Reference)(theResult.getChild(0))).getVarId();

		content[1] = sourceByte;
		content[0] = resultByte;

		setValue(content);
		removeAllChildren();

		//now really generate (attention : don't generate anything for the children elements,
		// they have already been taken into account when setting the content)
		return super.generate(buffer);
	}


}