package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.bytecode.Attribute;

/**
 * A GatewayAddress object stores the content of the gateway-address XML element
 * and generates the corresponding Gateway Address UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class GatewayAddress extends Element {
   /**
    * Create a new GatewayAddress object.
    */
   public GatewayAddress(Attributes atts) {
      setTagValue(Tag.GATEWAY_ADDRESS);

	  boolean SendAdditionalInfo = Conversion.yesNoStringToBoolean(atts.getValue("send-additional-info"));
      if (SendAdditionalInfo) {
         setAttribute(Attribute.GatewayAddress.SEND_ADDITIONAL_INFORMATION);
      }
   }

	public void setValue(String s)
	{
		value = Conversion.hexaStringToBytes(s);
	}
}