package UI_Converter.bytecode;

import java.io.ByteArrayOutputStream;
import UI_Converter.util.Element;

/**
 * A GeneralResultVariable object represents the temporary variable identifier
 * corresponding to the general-result-var XML element. It generates the
 * variable identifier.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class GeneralResultVariable extends Element {

   public GeneralResultVariable() {
	   System.out.println("GeneralResultVariable - Constructor");
	// Don't do anything because GeneralResultVariable is not a TLV. It only encapsulates
	// a 'reference' element.
   }

    //attention : don't generate any tag and neither generate the length
	public int generate(ByteArrayOutputStream buffer)
   {
	System.out.println("GeneralResultVariable - generate");
      int length = generateChildrenElements(buffer);
      return length;
   }
}