package UI_Converter.bytecode;

import UI_Converter.common.Tag;
import UI_Converter.util.Element;

/**
 * A GetLength object stores the content of the get-length XML element and
 * generates the corresponding Get Length UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class GetLength extends Element {
   /**
    * Create a new GetLength object.
    */
   public GetLength() {
      setTagValue(Tag.GET_LENGTH);
   }
}