package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;

/**
 * An InlineValue2 object stores the content of the inline-value2 XML element
 * and generates the corresponding Inline Value 2 UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class InlineValue2 extends InlineValue {
   /**
    * Create a new InlineValue2 object.
    *
    * @param atts Attributes of the inline-value2 XML element.
    *
    * @throw IllegalArgumentException if an XML attribute value is invalid.
    */
   public InlineValue2(Attributes atts)
                throws IllegalArgumentException {
      super(Tag.INLINE_VALUE2, atts);
   }
}