package UI_Converter.bytecode;

import java.io.ByteArrayOutputStream;
import UI_Converter.util.Element;

/**
 * An OutputVariable object stores the content of the output-var XML element and
 * generates the contained destination variable identifier.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class OutputVariable extends Element {
   /**
    * Generate the byte code for this output variable.
    *
    * @return the number of generated bytes.
    */
   public int generate(ByteArrayOutputStream buffer) {
      // Only generate the children elements, i.e. the variable identifier.
      return generateChildrenElements(buffer);
   }
}
