package UI_Converter.bytecode;

import UI_Converter.common.Tag;
import UI_Converter.util.Element;

/**
 * A PageReference object stores the content of the page-reference XML element
 * and generates the corresponding Page Reference UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class PageReference extends Element {
   /**
    * Create a new PageReference object.
    */
   public PageReference() {
      setTagValue(Tag.PAGE_REFERENCE);
   }
}