package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

public class PageUnlockCode extends Element
{

	private String kicInString;

	public PageUnlockCode(Attributes atts)
	{
		super();
		int cipher=0;
		setTagValue(Tag.PAGE_UNLOCK_CODE);

		//build the two bytes for "ciphering mode"
		String cipherS =atts.getValue("ciphering");
		if (cipherS!=null) 
		{
			if (cipherS.equals("DES")) cipher=1;
			else if (cipherS.equals("proprietary")) cipher=3;
		}
		
		//build the 2 bytes for "DES algorithm"
		int algo=0;
		String algoS=atts.getValue("DES-algo");
		if (algoS!=null)
		{
			if (algoS.equals("3DES-CBC-2keys")) algo=1;
			else if (algoS.equals("3DES-CBC-3keys")) algo=2;
			else if (algoS.equals("DES-ECB")) algo=3;
		}

		//build the 3 bytes for "key"
		int key=0;
		String keyS=atts.getValue("key");
		if (keyS!=null)
		{
			key = Conversion.stringToInt(keyS);
		}

		//build the KIC and put it in the buffer for future generation
		int KIC = cipher | (algo<<2) | (key<<4);

		byte[] KICinByteArray ={(byte)KIC};

		kicInString = Conversion.bytesToHexaString(KICinByteArray);

	}

	public void setValue(String s)
	{
		//attention : to avoid side effects due to the "trim", put the content directly in the Element
		value = Conversion.hexaStringToBytes(kicInString+s);
	  
	}


}