package UI_Converter.bytecode;

import java.io.ByteArrayOutputStream;
import UI_Converter.util.Conversion;
import UI_Converter.util.Element;

/**
 * A SimpleTLV object stores the content of the USAT-command-tlv XML
 * element and generates the corresponding Simple TLV Indicator UI-TLV.
 *
 *
 * @see 3GPP TS XX.YYY V0.0.1
 * @see 3GPP TS 31.113 V5.0.0
 */
public class SimpleTLV extends Element
{

	public SimpleTLV()
	{
		super();
	
	}

	 public int generate(ByteArrayOutputStream buffer) {
	  return generateValue(buffer);
   }

	 public void setValue(String s)
	{
      
		value = Conversion.hexaStringToBytes(s);
	  
	}

}
