package UI_Converter.bytecode;

import org.xml.sax.Attributes;
import UI_Converter.XMLmain;
import UI_Converter.util.Element;
import UI_Converter.common.Tag;
import java.io.ByteArrayOutputStream;
import UI_Converter.util.Conversion;
import UI_Converter.util.FileManager;


public class USATml extends Element
{

	public USATml(Attributes atts)
	{

		super();
		setTagValue(Tag.PAGE);

		if (atts.getValue("keep-all")!=null)
			if(atts.getValue("keep-all").equals("yes"))  setAttribute(Attribute.Page.KEEP_ALL);


		if (atts.getValue("dynamic")!=null)
			if (atts.getValue("dynamic").equals("yes")) setAttribute(Attribute.Page.DYNAMIC);
			

		if (atts.getValue("dcs")!=null) 
			if (atts.getValue("dcs").equals("ucs2")) setAttribute(Attribute.Page.UCS2);
	
	}


	public int generate(ByteArrayOutputStream buffer)
	{
		// generate the children elements
		int length = super.generate(buffer);

		// If the page element is just under the root element, then the byte code shall be displayed and printed
		if (XMLmain.PageElementJustUnderRootElement == true){

			// print out the byte-code to the screen and to the output file
			byte bytecode[] = Conversion.reverseBytes(buffer.toByteArray());
			System.out.println ("Byte code of page element is: " + Conversion.byteArrayToHexaString(bytecode));
		
			FileManager.InitOutputFile();
			FileManager.WriteInOutputFile(FileManager.LineSeparator);
			FileManager.WriteInOutputFile("Byte code of page element is: ");
			FileManager.WriteInOutputFile(Conversion.byteArrayToHexaString(bytecode));
			FileManager.CloseInOutputFile();
		}

		return length;
	}

}