package UI_Converter.bytecode;

import java.io.ByteArrayOutputStream;
import org.xml.sax.Attributes;
import UI_Converter.util.Conversion;

public class Value extends Pair {
   private boolean hexaValue;

   public Value(Attributes atts) 
   {
      String typeValue = atts.getValue("type");
	  if (typeValue!=null)
	  {
		if (typeValue.equals("hexa")) 
		{
         hexaValue = true;
		}
		else if (!typeValue.equals("cleartext")) 
		{
         throw new IllegalArgumentException("Invalid type value: " + typeValue);
		}
	  }
   }

   /**
    * Generate the byte code of the pair.
    *
    * @param buffer Buffer in which the byte code is generated.
    *
    * @return the number of generated bytes.
    */
   public int generate(ByteArrayOutputStream buffer) {
      int length = generateValue(buffer);
      length += generateBERTLVLength(length, buffer);
      return length;
   }

   /**
    * Generate the byte code of the pair.
    *
    * @param buffer Buffer in which the byte code is generated.
    *
    * @return the number of generated bytes.
    */
   public int generatePair(ByteArrayOutputStream buffer) {
      return generate(buffer);
   }

   public void setValue(String value) {
      if (!hexaValue) {
         super.setValue(value);
      }
      else {
         super.setValue(Conversion.hexaStringToBytes(value));
      }
   }
}
