package UI_Converter.bytecode;

/**
 * The Variable class contains constants related to the USAT Interpreter
 * variables.
 *
 * @author Philippe Sidler (SchlumbergerSema, sidler@montrouge.sema.slb.com)
 *
 * @see 3GPP TS 31.113 V5.0.0
 */
public class Variable {
   public static final int SUBSTITUTION_INDICATOR = 0xC0;

   public static final int FIRST_ENVIRONMENT_VARIABLE	= 0x00;
   public static final int FIRST_PERMANENT_VARIABLE		= 0x40;
   public static final int FIRST_TEMPORARY_VARIABLE		= 0x80;
   public static final int FIRST_STRING_ELEMENT			= 0xC0;
}