package UI_Converter.securedmsg;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.util.FileManager;
import java.io.*;

import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import com.sun.crypto.provider.SunJCE;


public class Uiappmsg extends Element
{

	private SecHeaders headers;
	public Uiappmsg(Attributes atts)
	{
		super();

		//create the header
		headers = new SecHeaders();

		String spiString = atts.getValue("spi");
		if (spiString!=null) 
		{
			headers.setSpi(Conversion.hexaStringToBytes(spiString));
			//to do heandling of second byte of spi.
		}

		String kicString = atts.getValue("kic");
		if (kicString!=null) headers.setKic(Conversion.hexaStringToByte(kicString));
		
		String kidString = atts.getValue("kid");
		if (kidString!=null) headers.setKid(Conversion.hexaStringToByte(kidString));	
		

		String tarString = atts.getValue("tar");
		if (tarString!=null) headers.setTar(Conversion.hexaStringToBytes(tarString));	

		
		String cntrString = atts.getValue("cntr");
		if (cntrString!=null) headers.setCntr(Conversion.hexaStringToBytes(cntrString));	
	
	}

	public int generate(ByteArrayOutputStream buffer)
	{
		byte[] SecuredMsg;

		// generate the children elements
		int length = generateChildrenElements(buffer);

		// print out the transport and byte-code layers to screen and output file
		byte clearSD[] = Conversion.reverseBytes(buffer.toByteArray());
		System.out.println ("The value of ui-app-msg is: " + Conversion.byteArrayToHexaString(clearSD));
		FileManager.InitOutputFile();
		FileManager.WriteInOutputFile(FileManager.LineSeparator);
		FileManager.WriteInOutputFile("The value of ui-app-msg is: ");
		FileManager.WriteInOutputFile(Conversion.byteArrayToHexaString(clearSD));

		try{
			//generate the 03.48 secured message
			SecuredMsg = headers.generate(clearSD);

			// print out the transport and byte-code layers to screen and output file
			System.out.println ("The 03.48 secured message is: " + Conversion.byteArrayToHexaString(SecuredMsg));
			FileManager.WriteInOutputFile(FileManager.LineSeparator);
			FileManager.WriteInOutputFile("The 03.48 secured message is: ");
			FileManager.WriteInOutputFile(Conversion.byteArrayToHexaString(SecuredMsg));
			FileManager.CloseInOutputFile();

			length += (SecuredMsg[0]*256 + SecuredMsg[1]);

		}

		catch(javax.crypto.NoSuchPaddingException ec1){
			System.out.println("Error: the exception javax.crypto.NoSuchPaddingException occured during 03.48 header generation.");
		}
		catch(javax.crypto.BadPaddingException ec2){
			System.out.println("Error: the exception javax.crypto.BadPaddingException occured during 03.48 header generation.");
		}
		catch(javax.crypto.IllegalBlockSizeException ec3){
			System.out.println("Error: the exception javax.crypto.IllegalBlockSizeException occured during 03.48 header generation.");
		}
		catch(java.security.NoSuchAlgorithmException es1){
			System.out.println("Error: the exception javax.security.NoSuchAlgorithmException occured during 03.48 header generation.");
		}
		catch(java.security.InvalidKeyException es2){
			System.out.println("Error: the exception javax.security.InvalidKeyException occured during 03.48 header generation.");
		}
		catch(java.security.InvalidAlgorithmParameterException es3){
			System.out.println("Error: the exception java.security.InvalidAlgorithmParameterException occured during 03.48 header generation.");
		}

		// return CPL
		return length;
	}

}