package UI_Converter.uimemsg;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.uimemsg.ProactiveConstants;

public class CommandDetails extends Element
{

	public CommandDetails(Attributes atts)
	{
		super();
		setTagValue(Tag.COMMAND_DETAILS);

		byte[] content = new byte[3];

		//handle the attribute "command-number"
		content[0] = Conversion.hexaStringToByte(atts.getValue("command-number"));

		// handle the attribute "command-type"
		String CommandType = atts.getValue("command-type");

		if (CommandType.compareTo("display-text") == 0)
		{
			content[1] = ProactiveConstants.DISPLAY_TEXT;
		}
		else
		if (CommandType.compareTo("select-item") == 0)
		{
			content[1] = ProactiveConstants.SELECT_ITEM;
		}
		else
		if (CommandType.compareTo("set-up-menu") == 0)
		{
			content[1] = ProactiveConstants.SET_UP_MENU;
		}
		else
		if (CommandType.compareTo("set-up-event-list") == 0)
		{
			content[1] = ProactiveConstants.SET_UP_MENU_EVENT_LIST;
		}
		else
		if (CommandType.compareTo("get-input") == 0)
		{
			content[1] = ProactiveConstants.GET_INPUT;
		}


		//handle the attribute "command-qualifier"
		content[2] = Conversion.hexaStringToByte(atts.getValue("command-qualifier"));

		value = content;

	}
}