package UI_Converter.uimemsg;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.uimemsg.ProactiveConstants;

public class DeviceIdentities extends Element
{

	public DeviceIdentities(Attributes atts)
	{
		super();
		setTagValue(Tag.DEVICE_IDENTITIES);

		byte[] content = new byte[2];

		//handle the attribute "source-device"
		content[0] = GetDeviceValue(atts.getValue("source-device"));

		//handle the attribute "source-device"
		content[1] = GetDeviceValue(atts.getValue("destination-device"));

		value = content;
	}

	private byte GetDeviceValue(String DeviceName)
	{
		if (DeviceName.length() == ("AdditionalCardReader".length() + 1)){
			String temp = DeviceName.substring(0, DeviceName.length() - 1);
			if (temp.compareTo("AdditionalCardReader") == 0){
				return (byte)(ProactiveConstants.ADDITIONAL_CARD_READER0 + Conversion.stringToByte(DeviceName.substring(DeviceName.length() - 1, DeviceName.length())));
			}
		}
		else
		if (DeviceName.length() == ("Channel".length() + 1)){
			String temp = DeviceName.substring(0, DeviceName.length() - 1);
			if (temp.compareTo("Channel") == 0){
				return (byte)(ProactiveConstants.CHANNEL1 - 1 + Conversion.stringToByte(DeviceName.substring(DeviceName.length() - 1, DeviceName.length())));
			}
		}
		else
		if (DeviceName.compareTo("Keypad") == 0){
			return ProactiveConstants.KEYPAD;
		}
		else
		if (DeviceName.compareTo("Display") == 0){
			return ProactiveConstants.DISPLAY;
		}
		else
		if (DeviceName.compareTo("UICC") == 0){
			return ProactiveConstants.UICC;
		}
		else
		if (DeviceName.compareTo("ME") == 0){
			return ProactiveConstants.ME;
		}
		else
		if (DeviceName.compareTo("Network") == 0){
			return ProactiveConstants.NETWORK;
		}

		return 0;
	}
}