package UI_Converter.uimemsg;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.uimemsg.ProactiveConstants;
import java.io.ByteArrayOutputStream;

public class EventType extends Element
{

	public EventType(Attributes atts)
	{
		super();

		byte[] content = new byte[1];

		// handle the attribute "icon-qualifier"
		String EventTypeId = atts.getValue("envent-type-id");

		if (EventTypeId.compareTo("MT-call") == 0)
		{
			content[0] = ProactiveConstants.MT_CALL;
		}
		else
		if (EventTypeId.compareTo("call-connected") == 0)
		{
			content[0] = ProactiveConstants.CALL_CONNECTED;
		}
		else
		if (EventTypeId.compareTo("call-disconnected") == 0)
		{
			content[0] = ProactiveConstants.CALL_DISCONNECTED;
		}
		else
		if (EventTypeId.compareTo("location-status") == 0)
		{
			content[0] = ProactiveConstants.LOCATION_STATUS;
		}
		else
		if (EventTypeId.compareTo("user-activity") == 0)
		{
			content[0] = ProactiveConstants.USER_ACTIVITY;
		}
		else
		if (EventTypeId.compareTo("idle-screen-available") == 0)
		{
			content[0] = ProactiveConstants.IDLE_SCREEN_AVAILABLE;
		}
		else
		if (EventTypeId.compareTo("card-reader-status") == 0)
		{
			content[0] = ProactiveConstants.CARD_READER_STATUS;
		}
		else
		if (EventTypeId.compareTo("language-selection") == 0)
		{
			content[0] = ProactiveConstants.LANGUAGE_SELECTION;
		}
		else
		if (EventTypeId.compareTo("browser-termination") == 0)
		{
			content[0] = ProactiveConstants.BW_TERMINATION;
		}
		else
		if (EventTypeId.compareTo("data-available") == 0)
		{
			content[0] = ProactiveConstants.DATA_AVAILABLE;
		}
		else
		if (EventTypeId.compareTo("channel-status") == 0)
		{
			content[0] = ProactiveConstants.CHANNEL_STATUS;
		}

		value = content;
	}

	public int generate(ByteArrayOutputStream buffer) {
		return generateValue(buffer);
	}
}