package UI_Converter.uimemsg;

import org.xml.sax.Attributes;
import UI_Converter.common.Tag;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.uimemsg.ProactiveConstants;

public class IconDescriptor extends Element
{

	public IconDescriptor(Attributes atts)
	{
		super();
		setTagValue(Tag.ICON_DESCRIPTOR);

		byte[] content = new byte[2];

		// handle the attribute "icon-qualifier"
		String IconQualifier = atts.getValue("icon-qualifier");

		if (IconQualifier.compareTo("self-explanatory") == 0)
		{
			content[0] = ProactiveConstants.SELF_EXPLANATORY;
		}
		else
		if (IconQualifier.compareTo("not-self-explanatory") == 0)
		{
			content[0] = ProactiveConstants.NOT_SELF_EXPLANATORY;
		}

		//handle the attribute "icon-identifier"
		content[1] = Conversion.hexaStringToByte(atts.getValue("icon-identifier"));

		value = content;

	}
}