package UI_Converter.uimemsg;

import java.io.ByteArrayOutputStream;
import org.xml.sax.Attributes;
import UI_Converter.util.Element;
import UI_Converter.util.Conversion;
import UI_Converter.common.Tag;

public class ItemDataObject extends Element
{
	private byte itemId;

	public ItemDataObject(Attributes atts)
	{
		super();
		setTagValue(Tag.ITEM);
		itemId = Conversion.hexaStringToByte(atts.getValue("item-identifier"));
	}

	public int generate(ByteArrayOutputStream buffer) {
		int length =generateValue(buffer);
		buffer.write(itemId);
		length++;
		length += generateBERTLVLength(length, buffer);
		length += generateTag(buffer);
		return(length);
	}

	public void setValue(String s)
	{
		value = Conversion.hexaStringToBytes(s);
	}
}