package UI_Converter.util;

public class Conversion 
{
	 public static String bytesToHexaString(byte[] bytes) {
      StringBuffer hexaString = new StringBuffer();
      for (int i = 0; i < bytes.length; i ++) {
         hexaString.append(byteToHexaDigit((byte) ((bytes[i] & 0xF0) >> 4)));
         hexaString.append(byteToHexaDigit((byte) (bytes[i] & 0x0F)));
      }
      return hexaString.toString();
   }
	
	 public static String bytesToHexaString(byte[] bytes, int offset, int length) {
      StringBuffer hexaString = new StringBuffer();
      length += offset;
      for (int i = 0; i < length; i ++) {
         hexaString.append(byteToHexaDigit((byte) ((bytes[i] & 0xF0) >> 4)));
         hexaString.append(byteToHexaDigit((byte) (bytes[i] & 0x0F)));
      }
      return hexaString.toString();
   }

	 public static String byteToHexaString(byte bytes) {
      StringBuffer hexaString = new StringBuffer();
      hexaString.append(byteToHexaDigit((byte) ((bytes & 0xF0) >> 4)));
      hexaString.append(byteToHexaDigit((byte) (bytes & 0x0F)));
      return hexaString.toString();
   }

	private static char byteToHexaDigit(byte b) {
      if (b < 0 || b > 15) {
         throw new IllegalArgumentException("Not a valid byte: " + b);
      }
      else if (b < 10) {
         return (char) ('0' + b);
      }
      else {
         return (char) ('A' + b - 10);
      }
   }
	
	private static byte hexaDigitToByte(char hexaDigit) {
      if (hexaDigit >= '0' && hexaDigit <= '9') {
         return (byte) (hexaDigit - '0');
      }
      else if (hexaDigit >= 'a' && hexaDigit <= 'f') {
         return (byte) (hexaDigit - 'a' + 10);
      }
      else if (hexaDigit >= 'A' && hexaDigit <= 'F') {
         return (byte) (hexaDigit - 'A' + 10);
      }
      else {
         throw new IllegalArgumentException("Not a valid hexadecimal digit: " + hexaDigit);
      }
   }

   public static byte hexaStringToByte(String hexaString) {
      if (hexaString.length() != 2) {
         throw new IllegalArgumentException("Not a valid hexadecimal string: " + hexaString);
      }
      return (byte) ((hexaDigitToByte(hexaString.charAt(0)) << 4) | hexaDigitToByte(hexaString.charAt(1)));
   }

   public static byte[] hexaStringToBytes(String hexaString) {
      int hexaStringLength = hexaString.length();
      if (hexaStringLength % 2 != 0) {
         throw new IllegalArgumentException("Not a valid hexadecimal string: " + hexaString);
      }
      byte[] binary = new byte[hexaStringLength / 2];
      for (int i = 0; i < binary.length; i ++) {
         binary[i] = (byte) ((hexaDigitToByte(hexaString.charAt(2 * i)) << 4) | hexaDigitToByte(hexaString.charAt(2 * i + 1)));
      }
      return binary;
   }

   public static int stringToInt(String value) {
      try {
         return Integer.parseInt(value);
      }
      catch (NumberFormatException e) {
         throw new IllegalArgumentException("Not a valid decimal number: " + value);
      }
   }

   public static byte stringToByte(String value) {
      try {
         return Byte.parseByte(value);
      }
      catch (NumberFormatException e) {
         throw new IllegalArgumentException("Not a valid decimal number: " + value);
      }
   }

   public static String byteArrayToHexaString(byte[] byteArray)
	{
		String toReturn = new String();
		int j=0;
		for (int i = 0; i < byteArray.length; i ++) 
		{
			toReturn = toReturn + byteToString(byteArray[i]); 
		}
		return toReturn;
   }

   public static String byteToString(byte b)
   {
		Byte b1=new Byte(b);
		//Integer i1=new Integer(b1.intValue());
		
		int i1 = b1.intValue();
		if (i1<0) i1=i1+256;

		String s=Integer.toHexString(i1);

		//warning : add a "0" if needeed.
		if (s.length()==1) s="0"+s;
		return (s);
   }

   public static int byteToInt(byte byteValue) {
      return byteValue & 0xFF;
   }


   public static boolean yesNoStringToBoolean(String yesNoString) {
      return yesNoString.equals("yes");
   }

	public static byte[] reverseByteArray(byte[] bArray)
	{
		byte[] toReturn = new byte[bArray.length];

		for (int i=0; i<bArray.length;i++)
		{
			toReturn[(bArray.length)-i-1]=bArray[i];
		}
		return toReturn;
	}


	 public static byte[] reverseBytes(byte[] bytes) {
      byte[] newBytes = new byte[bytes.length];
      for (int i = 0; i < bytes.length; i ++) {
         newBytes[i] = bytes[bytes.length - i - 1];
      }
      return newBytes;
   }

}