package UI_Converter.util;

import UI_Converter.util.Conversion;
import java.io.*;


public class FileManager{

	private static String		InputFileName;

	private static String		OutputFileName;
	private static File			OutputFile;
	private static FileWriter	OutputFileWriter;

	private static String			TransportKeyFileName;
	private static File				TransportKeyFile;
	private static RandomAccessFile TransportKeyRandom;

	public static String	LineSeparator = System.getProperty("line.separator");

	public static void SetInputFileName(String FileName) {
		InputFileName = FileName;
	}

	public static void SetOutputFile(String FileName) {
		OutputFileName = FileName;
	}

	public static void SetTransportKeyFile(String FileName) {
		TransportKeyFileName = FileName;
	}

	public static void InitOutputFile() {
		try{
			OutputFile = new File(OutputFileName);
			OutputFileWriter = new FileWriter(OutputFile);
			OutputFileWriter.write("Conversion of: " + InputFileName);
		}
		catch(java.io.IOException e){
			System.out.println("Error: Pb with the file " + OutputFileName + ": " + e.getMessage());
		}
	}

	public static void WriteInOutputFile(String TheString) {

		try{
			OutputFileWriter.write(LineSeparator + TheString);
		}
		catch(java.io.IOException e){
			System.out.println("Error: Pb  with the file " + OutputFileName + ": " + e.getMessage());
		}
	}

	public static void CloseInOutputFile() {
		try{
			OutputFileWriter.close();
		}
		catch(java.io.IOException e){
			System.out.println("Error: Pb with the file " + OutputFileName + ": " + e.getMessage());
		}
	}

	public static byte[] GetCipherKeyFromKeyFile(byte KeyIndex) {
		return(GetKeyInTransportKeyFile("KIc" + KeyIndex));
	}

	public static byte[] GetSignatureKeyFromKeyFile(byte KeyIndex) {
		return(GetKeyInTransportKeyFile("KId" + KeyIndex));
	}

	private static byte[] GetKeyInTransportKeyFile(String KeyName){
		
		String Line;
		boolean EOF = false;

		try{
			TransportKeyFile = new File(TransportKeyFileName);
			TransportKeyRandom = new RandomAccessFile(TransportKeyFile, "r");

			while (!EOF) {

				Line = TransportKeyRandom.readLine();

				if (KeyName.compareTo(String.copyValueOf( Line.toCharArray(), 0, KeyName.length() )) == 0){
					TransportKeyRandom.close();
					return(Conversion.hexaStringToBytes(String.copyValueOf(Line.toCharArray(), Line.indexOf("\"") + 1, Line.lastIndexOf("\"") - Line.indexOf("\"") - 1)));
				}

			}
			System.out.println("Error: the key " + KeyName + " is not found in " + TransportKeyFileName); 

			TransportKeyRandom.close();
		}
		catch(java.io.IOException e){
			System.out.println("Error: Pb with the file " + TransportKeyFileName + ": " + e.getMessage());
		}
		return null;
	}
}
