package UI_Converter.util;

public class TLAV extends TLV {
   private byte[] attributes;

   private TLAV(byte tag, byte[] attributes, byte[] value) {
      super(tag, value);
      this.attributes = attributes;
   }

   public byte[] getAttributes() {
      return attributes;
   }

	public int getAttributeValue(int offset, int mask) {
      if (offset < 0 || offset > 6) {
         throw new IllegalArgumentException();
      }
      if (attributes == null) {
         return 0;
      }
      else {
         return (Conversion.byteToInt(attributes[0]) >> offset) & mask;
      }
   }

   public boolean isAttributeSet(int index) {
      if (attributes == null) {
         return false;
      }
      else {
         int offset = index / 8;
         if (attributes.length <= offset) {
            return false;
         }
         else {
            index = index % 8;
            return (Conversion.byteToInt(attributes[offset]) & (1 << index)) != 0;
         }
      }
   }

   public static TLAV parseTLAV(byte[] bytecode, IntegerRef offset) {
      TLV tlv = parseTLV(bytecode, offset);
      byte tag = tlv.getTag();
      byte[] attributes = null;
      byte[] value = tlv.getValue();
      if ((Conversion.byteToInt(tag) & 0x80) != 0) {
         tag &= 0x7F;
         int attributeLength = 1;
         for (int i = 0; (Conversion.byteToInt(value[i]) & 0x80) != 0; i ++) {
            attributeLength ++;
         }
         attributes = Array.extract(value, 0, attributeLength);
         value = Array.extract(value, attributeLength);
      }
      return new TLAV(tag, attributes, value);
   }
}