package UI_Converter.util;

public class TLV {
   private byte tag;

   private byte[] value;

   protected TLV(byte tag, byte[] value) {
      this.tag   = tag;
      this.value = value;
   }

   public int getLength() {
      return value.length;
   }

   public byte getTag() {
      return tag;
   }

   public byte[] getValue() {
      return value;
   }

   public static TLV parseTLV(byte[] bytecode, IntegerRef offset) {
      byte tag = bytecode[offset.value ++];
      int length = getBERLength(bytecode, offset);
      byte[] value = Array.extract(bytecode, offset.value, length);
      offset.value += length;
      return new TLV(tag, value);
   }

   public static int getBERLength(byte[] bytecode, IntegerRef offset) {
      int length = Conversion.byteToInt(bytecode[offset.value ++]);
      if (length > 0x7F) {
         switch (length) {
            case 0x81:
               return Conversion.byteToInt(bytecode[offset.value ++]);

            case 0x82:
               return Conversion.byteToInt(bytecode[offset.value ++]) << 8
                      | Conversion.byteToInt(bytecode[offset.value ++]);

            default:
               System.err.println("Bad BER length: 0x" + Integer.toHexString(length));
               break;
         }
      }
      return length;
   }
}